/*
 * Initialization and test data for SuperCrypt chip.
 *
 * Linux developers:
 * 	Michal Ludvig <michal@logix.cz>
 *	              http://www.logix.cz/michal
 *
 * Most vectors were taken from the original fcrypt-2.00 driver.
 *
 * Original file:
 *		Copyright (C) 1999 CE Infosys GmbH, <sales@ce-infosys.com>
 *		http://www.ce-infosys.com
 *
 * Authors:	Benjamin Reichardt, <reichard@math.uni-goettingen.de>
 *		derived from code provided by CE Infosys
 *
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 */
#ifndef _FCRYPT_REFDAT_H
#define _FCRYPT_REFDAT_H

#define MAX_BLOCKS      16

unsigned char ref_key_1[8] =
{ 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07 };

//---------------Reference data ECB-Mode (ENC):
// Input
#define ecb_nr_blocks           MAX_BLOCKS
unsigned char ecb_ref_input[ecb_nr_blocks*8] = {
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87,
  0xF0, 0xE1, 0xD2, 0xC3, 0xB4, 0xA5, 0x96, 0x87
};
// Output Enc
unsigned char ecb_enc_ref_output[ecb_nr_blocks*8] = {
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67,
  0x45, 0x09, 0xeb, 0xab, 0x25, 0xb2, 0x31, 0x67
};
// Output Dec
unsigned char ecb_dec_ref_output[ecb_nr_blocks*8] = {
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3, 
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3,
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3, 
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3,
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3, 
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3,
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3, 
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3,
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3, 
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3,
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3, 
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3,
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3, 
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3,
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3, 
  0x41, 0xc9, 0x4b, 0xaf, 0xbe, 0x8b, 0x26, 0xf3
};


//------------------Reference data CBC-Mode (ENC):

#define cbc_nr_blocks 10

// Input
unsigned char cbc_enc_ref_input[cbc_nr_blocks * 8] = {
  0xf0, 0xe1, 0xd2, 0xc3, 0xb4, 0xa5, 0x96, 0x87,
  0xf0, 0xe1, 0xd2, 0xc3, 0xb4, 0xa5, 0x96, 0x87,
  0xf0, 0xe1, 0xd2, 0xc3, 0xb4, 0xa5, 0x96, 0x87,
  0xf0, 0xe1, 0xd2, 0xc3, 0xb4, 0xa5, 0x96, 0x87,
  0xf0, 0xe1, 0xd2, 0xc3, 0xb4, 0xa5, 0x96, 0x87,
  0xf0, 0xe1, 0xd2, 0xc3, 0xb4, 0xa5, 0x96, 0x87,
  0xf0, 0xe1, 0xd2, 0xc3, 0xb4, 0xa5, 0x96, 0x87,
  0xf0, 0xe1, 0xd2, 0xc3, 0xb4, 0xa5, 0x96, 0x87,
  0xf0, 0xe1, 0xd2, 0xc3, 0xb4, 0xa5, 0x96, 0x87,
  0xf0, 0xe1, 0xd2, 0xc3, 0xb4, 0xa5, 0x96, 0x87
};

//Initial Vector

unsigned char cbc_iv[8] =
{ 0x80, 0x91, 0xa2, 0xb3, 0xc4, 0xd5, 0xe6, 0xf7};

// Output:

unsigned char cbc_enc_ref_output[cbc_nr_blocks * 8] = {
  0xa1, 0x74, 0x86, 0x5a, 0x84, 0xa7, 0xb7, 0xd4,
  0x1c, 0x9d, 0x9c, 0xfc, 0xbf, 0x58, 0x32, 0xea,
  0x3c, 0xfe, 0x1c, 0xaa, 0x0c, 0xa5, 0x16, 0x42,
  0x1d, 0x14, 0xbc, 0xa7, 0xeb, 0x16, 0x0f, 0x38,
  0x76, 0x2a, 0x06, 0x13, 0xc0, 0x32, 0xb5, 0x7c,
  0xc0, 0xa8, 0x53, 0x29, 0x5c, 0x59, 0xee, 0x6b,
  0xaf, 0x08, 0xf5, 0xd5, 0x5e, 0x7c, 0xeb, 0x79,
  0x44, 0x14, 0x2a, 0x7c, 0x7d, 0xe2, 0xb4, 0xbd,
  0x59, 0xfd, 0x13, 0x2f, 0x92, 0x3f, 0xc5, 0x21,
  0x59, 0xe0, 0xfc, 0x5d, 0x87, 0xb5, 0x20, 0xaa
};

//------------------Reference data CBC-Mode (DEC):

// Initial Vector: == cbc_iv
// nr_blocks == cbc_nr_blocks	 

//Input
unsigned char cbc_dec_ref_input[cbc_nr_blocks*8] = {
  0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,
  0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22,
  0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33, 0x33,
  0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44,
  0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
  0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66,
  0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77, 0x77,
  0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88,
  0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99, 0x99,
  0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa
};

// Output:
unsigned char cbc_dec_ref_output[cbc_nr_blocks * 8] = {
  0x09, 0xb1, 0x08, 0x93, 0xfb, 0x84, 0x8d, 0xb4,
  0x11, 0x23, 0xb9, 0x2c, 0xa8, 0xf1, 0xe5, 0x79,
  0xae, 0x90, 0xe7, 0xd2, 0xa4, 0xa7, 0xd2, 0x28,
  0xea, 0xcf, 0xac, 0x78, 0x98, 0xa5, 0x51, 0x27,
  0x54, 0xde, 0x38, 0x0e, 0xf7, 0x0e, 0x0e, 0x0d,
  0x7a, 0x68, 0x1d, 0x65, 0x28, 0x7b, 0x4c, 0xf9,
  0xba, 0xab, 0x84, 0x2f, 0xa2, 0xbd, 0xd8, 0x03,
  0xd9, 0x6f, 0x25, 0xc1, 0x4d, 0x3e, 0x17, 0x7d,
  0x40, 0xf2, 0x30, 0x0c, 0x60, 0x71, 0x37, 0x55,
  0x55, 0x19, 0xa2, 0x04, 0x08, 0x4b, 0xdb, 0x45
};

/* ==================== 3DES-CBC ==================== */

unsigned char cbc3_ref_key[] = {
	0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 
	0x39, 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 
	0x37, 0x38, 0x39, 0x30, 0x31, 0x32, 0x33, 0x34, 
};

unsigned char cbc3_ref_iv[] = {
  0x21, 0xf0, 0xf3, 0x9f, 0xec, 0x7f, 0x25, 0xf5, 
};
unsigned char cbc3_ref_enc[] = {
  0x93, 0x03, 0x04, 0xa3, 0x9f, 0x4f, 0x3c, 0xd2, 
  0x22, 0x72, 0xe8, 0x34, 0xcf, 0x28, 0xf2, 0x10, 
  0x8f, 0xd3, 0x97, 0x5b, 0x0f, 0xd3, 0xb4, 0xd9, 
  0x90, 0x32, 0x99, 0x86, 0x84, 0xdd, 0xbe, 0x12, 
  0x32, 0xb3, 0xe2, 0xb2, 0x83, 0x16, 0x5f, 0xd5, 
  0xd6, 0x7f, 0xd2, 0x66, 0xee, 0xf7, 0xb3, 0x18, 
  0x9e, 0x09, 0x16, 0x4a, 0xe0, 0xfb, 0x13, 0x30, 
  0xb1, 0x48, 0x40, 0x81, 0xab, 0xa9, 0xb8, 0x12, 
  0xaa, 0x75, 0x63, 0xff, 0x4b, 0x5f, 0xb1, 0x77, 
};
unsigned char cbc3_ref_dec[] = {
  0x08, 0x00, 0x93, 0xfe, 0x7b, 0x0c, 0x00, 0x03, 
  0x2c, 0x11, 0x81, 0x41, 0x4d, 0x9c, 0x03, 0x00, 
  0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f, 
  0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 
  0x18, 0x19, 0x1a, 0x1b, 0x1c, 0x1d, 0x1e, 0x1f, 
  0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 
  0x28, 0x29, 0x2a, 0x2b, 0x2c, 0x2d, 0x2e, 0x2f, 
  0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 
  0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x06, 0x01, 
};

/* ========== Here is all comes together. ========== */
struct fcrypt_test_vectors {
	unsigned char	*ref_input;
	unsigned char	*ref_output;
	unsigned char	*iv;
	unsigned char	*key;
	size_t		bytes;
	const char	*label;
	int		mode;
};

struct fcrypt_test_vectors fcrypt_test_vectors[] = {
	{
		ecb_ref_input,
		ecb_enc_ref_output,
		NULL,
		ref_key_1,
		ecb_nr_blocks * 8,
		"ECB encryption",
		ECB_MODE | ENCODE
	}, {
		ecb_ref_input,
		ecb_dec_ref_output,
		NULL,
		ref_key_1,
		ecb_nr_blocks * 8,
		"ECB decryption",
		ECB_MODE | DECODE
	}, {
		cbc_enc_ref_input,
		cbc_enc_ref_output,
		cbc_iv,
		ref_key_1,
		cbc_nr_blocks * 8,
		"CBC encryption",
		CBC_MODE | ENCODE
	}, {
		cbc_dec_ref_input,
		cbc_dec_ref_output,
		cbc_iv,
		ref_key_1,
		cbc_nr_blocks * 8,
		"CBC decryption",
		CBC_MODE | DECODE
	}, {
		cbc3_ref_enc,
		cbc3_ref_dec,
		cbc3_ref_iv,
		cbc3_ref_key,
		sizeof(cbc3_ref_dec),
		"CBC3 decryption",
		CBC_MODE | DECODE | TRIPLE_CIPHER
	}, {
		cbc3_ref_dec,
		cbc3_ref_enc,
		cbc3_ref_iv,
		cbc3_ref_key,
		sizeof(cbc3_ref_dec),
		"CBC3 encryption",
		CBC_MODE | ENCODE | TRIPLE_CIPHER
	}
};
#define num_fcrypt_test_vectors	(sizeof(fcrypt_test_vectors)/sizeof(fcrypt_test_vectors[0]))

/*
 * X-Box initialization data.
 *
 *		Copyright (C) 1999 CE Infosys GmbH, <sales@ce-infosys.com>
 *		http://www.ce-infosys.com
 *
 * Authors:	Benjamin Reichardt, <reichard@math.uni-goettingen.de>
 *		derived from code provided by CE Infosys
 */

#define X_BOX_SIZE      512

static unsigned char gXBox_Data[X_BOX_SIZE] =
{      
  0xfe,0x7a,0xc2,0xd4,0x14,0xd0,0x1c,0x2b,
  0x8d,0xe9,0xa4,0x82,0xe1,0x3e,0xf1,0x4e,
  0x62,0x06,0x97,0x6f,0xbf,0x63,0x2a,0xf0,
  0x3b,0x9f,0x6b,0xb8,0x48,0xa5,0x86,0x1d,
  0x93,0x11,0x08,0xa3,0x7a,0x2d,0xd5,0x9c,
  0x26,0x8c,0x33,0x39,0xdc,0x57,0x4f,0xe7,
  0xc5,0xbb,0xed,0x55,0x09,0xc4,0x70,0x0a,
  0x50,0x42,0x5e,0xc6,0xa7,0xf8,0xb9,0x71,
  0x30,0xdd,0xae,0x1d,0xdf,0x87,0xfb,0xf0,
  0x47,0xb0,0x42,0xdb,0x74,0x59,0x2c,0x87,
  0xfe,0x63,0x74,0xa4,0x22,0xf4,0xc7,0x39,
  0x8d,0x06,0x9d,0x71,0xe1,0x3a,0x51,0x4a,
  0xca,0x42,0x65,0xce,0x06,0x78,0x10,0x53,
  0x1c,0x25,0xdf,0x65,0xab,0xce,0xea,0xbc,
  0x69,0x1c,0x03,0x02,0x95,0xab,0xb9,0xef,
  0xb3,0xef,0x38,0x98,0x58,0x91,0x86,0x26,
  0x04,0xad,0x94,0x71,0xe1,0x66,0xe2,0xb4,
  0x7e,0x94,0xf1,0x4b,0xb8,0x09,0x5b,0x1d,
  0xad,0xc8,0x2a,0x9c,0x46,0xbf,0x8d,0xc3,
  0xd2,0x73,0xc7,0xe7,0x1b,0xd0,0x38,0x2e,
  0x5f,0xfb,0x7f,0x0a,0x8c,0x11,0x09,0x6f,
  0xc9,0x32,0x4c,0xa6,0x67,0xec,0xa5,0xd8,
  0x93,0x55,0x16,0xf0,0x3a,0x2a,0xd3,0x35,
  0x25,0x8e,0xb0,0x59,0xf0,0x47,0x6e,0x82,
  0xdf,0x31,0x4b,0x26,0x8c,0xfa,0x38,0x1b,
  0xa8,0x0d,0x2c,0xed,0x12,0x60,0xc7,0x78,
  0x34,0xa6,0x91,0x41,0xf9,0x19,0x5e,0xa4,
  0x41,0xd8,0xf2,0x8a,0x27,0x87,0xad,0xd7,
  0xb5,0x94,0xb6,0xf9,0x6b,0x4f,0xef,0xc5,
  0x73,0x5e,0x10,0x90,0xce,0xb3,0x79,0x0f,
  0x0a,0xcb,0x6a,0x3e,0x50,0x75,0x04,0x52,
  0xe6,0x22,0x85,0x63,0x9d,0xec,0xd3,0xbc,
// second part                      
  0xfe,0x7a,0xc2,0xd4,0x14,0xd0,0x1c,0x2b,
  0x8d,0xe9,0xa4,0x82,0xe1,0x3e,0xf1,0x4e,
  0x62,0x06,0x97,0x6f,0xbf,0x63,0x2a,0xf0,
  0x3b,0x9f,0x6b,0xb8,0x48,0xa5,0x86,0x1d,
  0x93,0x11,0x08,0xa3,0x7a,0x2d,0xd5,0x9c,
  0x26,0x8c,0x33,0x39,0xdc,0x57,0x4f,0xe7,
  0xc5,0xbb,0xed,0x55,0x09,0xc4,0x70,0x0a,
  0x50,0x42,0x5e,0xc6,0xa7,0xf8,0xb9,0x71,
  0x30,0xdd,0xae,0x1d,0xdf,0x87,0xfb,0xf0,
  0x47,0xb0,0x42,0xdb,0x74,0x59,0x2c,0x87,
  0xfe,0x63,0x74,0xa4,0x22,0xf4,0xc7,0x39,
  0x8d,0x06,0x9d,0x71,0xe1,0x3a,0x51,0x4a,
  0xca,0x42,0x65,0xce,0x06,0x78,0x10,0x53,
  0x1c,0x25,0xdf,0x65,0xab,0xce,0xea,0xbc,
  0x69,0x1c,0x03,0x02,0x95,0xab,0xb9,0xef,
  0xb3,0xef,0x38,0x98,0x58,0x91,0x86,0x26,
  0x04,0xad,0x94,0x71,0xe1,0x66,0xe2,0xb4,
  0x7e,0x94,0xf1,0x4b,0xb8,0x09,0x5b,0x1d,
  0xad,0xc8,0x2a,0x9c,0x46,0xbf,0x8d,0xc3,
  0xd2,0x73,0xc7,0xe7,0x1b,0xd0,0x38,0x2e,
  0x5f,0xfb,0x7f,0x0a,0x8c,0x11,0x09,0x6f,
  0xc9,0x32,0x4c,0xa6,0x67,0xec,0xa5,0xd8,
  0x93,0x55,0x16,0xf0,0x3a,0x2a,0xd3,0x35,
  0x25,0x8e,0xb0,0x59,0xf0,0x47,0x6e,0x82,
  0xdf,0x31,0x4b,0x26,0x8c,0xfa,0x38,0x1b,
  0xa8,0x0d,0x2c,0xed,0x12,0x60,0xc7,0x78,
  0x34,0xa6,0x91,0x41,0xf9,0x19,0x5e,0xa4,
  0x41,0xd8,0xf2,0x8a,0x27,0x87,0xad,0xd7,
  0xb5,0x94,0xb6,0xf9,0x6b,0x4f,0xef,0xc5,
  0x73,0x5e,0x10,0x90,0xce,0xb3,0x79,0x0f,
  0x0a,0xcb,0x6a,0x3e,0x50,0x75,0x04,0x52,
  0xe6,0x22,0x85,0x63,0x9d,0xec,0xd3,0xbc
};    // X-Box end
#endif
